"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chalk_1 = require("chalk");
const cli_utils_1 = require("@ionic/cli-utils");
const namespace_1 = require("@ionic/cli-utils/lib/namespace");
const common_1 = require("./common");
class PackageNamespace extends namespace_1.Namespace {
    getMetadata() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return {
                name: 'package',
                description: 'Commands for Ionic Package',
                longDescription: `${chalk_1.default.bold.yellow('WARNING')}: ${common_1.DEPRECATION_NOTICE}`,
                groups: [cli_utils_1.NamespaceGroup.Deprecated],
            };
        });
    }
    getCommands() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return new namespace_1.CommandMap([
                ['build', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { PackageBuildCommand } = yield Promise.resolve().then(() => require('./build')); return new PackageBuildCommand(this, this.env); })],
                ['download', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { PackageDownloadCommand } = yield Promise.resolve().then(() => require('./download')); return new PackageDownloadCommand(this, this.env); })],
                ['info', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { PackageInfoCommand } = yield Promise.resolve().then(() => require('./info')); return new PackageInfoCommand(this, this.env); })],
                ['list', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { PackageListCommand } = yield Promise.resolve().then(() => require('./list')); return new PackageListCommand(this, this.env); })],
            ]);
        });
    }
}
exports.PackageNamespace = PackageNamespace;
